---
title: WebRTC connectivity
slug: Web/API/WebRTC_API/Connectivity
tags:
  - API
  - Advanced
  - Audio
  - Draft
  - Guide
  - Media
  - Video
  - WebRTC
---
<div>{{WebRTCSidebar}}{{draft}}</div>

<p><span class="seoSummary">This article describes how the various WebRTC-related protocols interact with one another in order to create a connection and transfer data and/or media among peers.</span></p>

<div class="note">
<p><strong>Note:</strong> This page needs heavy rewriting for structural integrity and content completeness. Lots of info here is good but the organization is a mess since this is sort of a dumping ground right now.</p>
</div>

<h2 id="Signaling">Signaling</h2>

<p>Unfortunately, WebRTC can’t create connections without some sort of server in the middle. We call this the <strong>signal channel</strong> or <strong>signaling service</strong>. It’s any sort of channel of communication to exchange information before setting up a connection, whether by email, post card or a carrier pigeon... it’s up to you.</p>

<p>The information we need to exchange is the Offer and Answer which just contains the {{Glossary("SDP")}} mentioned below.</p>

<p>Peer A who will be the initiator of the connection, will create an Offer. They will then send this offer to Peer B using the chosen signal channel. Peer B will receive the Offer from the signal channel and create an Answer. They will then send this back to Peer A along the signal channel.</p>

<h3 id="Session_descriptions">Session descriptions</h3>

<p>The configuration of an endpoint on a WebRTC connection is called a <strong>session description</strong>. The description includes information about the kind of media being sent, its format, the transfer protocol being used, the endpoint's IP address and port, and other information needed to describe a media transfer endpoint. This information is exchanged and stored using <strong>Session Description Protocol</strong> ({{Glossary("SDP")}}); if you want details on the format of SDP data, you can find it in {{RFC(2327)}}.</p>

<p>When a user starts a WebRTC call to another user, a special description is created called an <strong>offer</strong>. This description includes all the information about the caller's proposed configuration for the call. The recipient then responds with an <strong>answer</strong>, which is a description of their end of the call. In this way, both devices share with one another the information needed in order to exchange media data. This exchange is handled using Interactive Connectivity Establishment ({{Glossary("ICE")}}, a protocol which lets two devices use an intermediary to exchange offers and answers even if the two devices are separated by Network Address Translation ({{Glossary("NAT")}}).</p>

<p>Each peer, then, keeps two descriptions on hand: the <strong>local description</strong>, describing itself, and the <strong>remote description</strong>, describing the other end of the call.</p>

<p>The offer/answer process is performed both when a call is first established, but also any time the call's format or other configuration needs to change. Regardless of whether it's a new call, or reconfiguring an existing one, these are the basic steps which must occur to exchange the offer and answer, leaving out the ICE layer for the moment:</p>

<ol>
 <li>The caller captures local Media via {{domxref("navigator.mediaDevices.getUserMedia()")}} </li>
 <li>The caller creates <code>RTCPeerConnection</code> and called {{domxref("RTCPeerConnection.addTrack()")}} (Since <code>addStream</code> is deprecating)</li>
 <li>The caller calls {{domxref("RTCPeerConnection.createOffer()")}} to create an offer.</li>
 <li>The caller calls {{domxref("RTCPeerConnection.setLocalDescription()")}} to set that offer as the <em>local description</em> (that is, the description of the local end of the connection).</li>
 <li>After setLocalDescription(), the caller asks STUN servers to generate the ice candidates</li>
 <li>The caller uses the signaling server to transmit the offer to the intended receiver of the call.</li>
 <li>The recipient receives the offer and calls {{domxref("RTCPeerConnection.setRemoteDescription()")}} to record it as the <em>remote description</em> (the description of the other end of the connection).</li>
 <li>The recipient does any setup it needs to do for its end of the call: capture its local media, and attach each media tracks into the peer connection via {{domxref("RTCPeerConnection.addTrack()")}}</li>
 <li>The recipient then creates an answer by calling {{domxref("RTCPeerConnection.createAnswer()")}}.</li>
 <li>The recipient calls {{domxref("RTCPeerConnection.setLocalDescription()")}}, passing in the created answer, to set the answer as its local description. The recipient now knows the configuration of both ends of the connection.</li>
 <li>The recipient uses the signaling server to send the answer to the caller.</li>
 <li>The caller receives the answer.</li>
 <li>The caller calls {{domxref("RTCPeerConnection.setRemoteDescription()")}} to set the answer as the remote description for its end of the call. It now knows the configuration of both peers. Media begins to flow as configured.</li>
</ol>

<h3 id="Pending_and_current_descriptions">Pending and current descriptions</h3>

<p>Taking one step deeper into the process, we find that <code>localDescription</code> and <code>remoteDescription</code>, the properties which return these two descriptions, aren't as simple as they look. Because during renegotiation, an offer might be rejected because it proposes an incompatible format, it's necessary that each endpoint have the ability to propose a new format but not actually switch to it until it's accepted by the other peer. For that reason, WebRTC uses <em>pending</em> and <em>current</em> descriptions.</p>

<p>The <strong>current description</strong> (which is returned by the {{domxref("RTCPeerConnection.currentLocalDescription")}} and {{domxref("RTCPeerConnection.currentRemoteDescription")}} properties) represents the description currently in actual use by the connection. This is the most recent connection that both sides have fully agreed to use.</p>

<p>The <strong>pending description</strong> (returned by {{domxref("RTCPeerConnection.pendingLocalDescription")}} and {{domxref("RTCPeerConnection.pendingRemoteDescription")}}) indicates a description which is currently under consideration following a call to  <code>setLocalDescription()</code> or <code>setRemoteDescription()</code>, respectively.</p>

<p>When reading the description (returned by {{domxref("RTCPeerConnection.localDescription")}} and {{domxref("RTCPeerConnection.remoteDescription")}}), the returned value is the value of <code>pendingLocalDescription</code>/<code>pendingRemoteDescription</code> if there's a pending description (that is, the pending description isn't <code>null</code>); otherwise, the current description (<code>currentLocalDescription</code>/<code>currentRemoteDescription</code>) is returned.</p>

<p>When changing the description by calling <code>setLocalDescription()</code> or <code>setRemoteDescription()</code>, the specified description is set as the pending description, and the WebRTC layer begins to evaluate whether or not it's acceptable. Once the proposed description has been agreed upon, the value of <code>currentLocalDescription</code> or <code>currentRemoteDescription</code> is changed to the pending description, and the pending description is set to null again, indicating that there isn't a pending description.</p>

<div class="note">
<p>The <code>pendingLocalDescription</code> contains not just the offer or answer under consideration, but any local ICE candidates which have already been gathered since the offer or answer was created. Similarly, <code>pendingRemoteDescription</code> includes any remote ICE candidates which have been provided by calls to {{domxref("RTCPeerConnection.addIceCandidate()")}}.</p>
</div>

<p>See the individual articles on these properties and methods for more specifics, and <a href="/en-US/docs/Web/Media/Formats/WebRTC_codecs">Codecs used by WebRTC</a> for information about codecs supported by WebRTC and which are compatible with which browsers. The codecs guide also offers guidance to help you choose the best codecs for your needs.</p>

<h2 id="ICE_candidates">ICE candidates</h2>

<p>As well as exchanging information about the media (discussed above in Offer/Answer and SDP), peers must exchange information about the network connection. This is known as an <strong>ICE candidate</strong> and details the available methods the peer is able to communicate (directly or through a TURN server). Typically, each peer will propose its best candidates first, making their way down the line toward their worse candidates. Ideally, candidates are UDP (since it's faster, and media streams are able to recover from interruptions relatively easily), but the ICE standard does allow TCP candidates as well.</p>

<div class="note">
<p>Generally, ICE candidates using TCP are only going to be used when UDP is not available or is restricted in ways that make it not suitable for media streaming. Not all browsers support ICE over TCP, however.</p>
</div>

<p>ICE allows candidates to represent connections over either {{Glossary("TCP")}} or {{Glossary("UDP")}}, with UDP generally being preferred (and being more widely supported). Each protocol supports a few types of candidate, with the candidate types defining how the data makes its way from peer to peer.</p>

<h3 id="UDP_candidate_types">UDP candidate types</h3>

<p>UDP candidates (candidates with their {{domxref("RTCIceCandidate.protocol", "protocol")}} set to <code>udp</code>) can be one of these types:</p>

<dl>
 <dt><code>host</code></dt>
 <dd>A host candidate is one for which its {{domxref("RTCIceCandidate.ip", "ip")}} address is the actual, direct IP address of the remote peer.</dd>
 <dt><code>prflx</code></dt>
 <dd>A peer reflexive candidate is one whose IP address comes from a symmetric NAT between the two peers, usually as an additional candidate during trickle ICE (that is, additional candidate exchanges that occur after primary signaling but before the connection verification phase is finished).</dd>
 <dt><code>srflx</code></dt>
 <dd>A server reflexive candidate is generated by a STUN/TURN server; the connection's initiator requests a candidate from the STUN server, which forwards the request through the remote peer's NAT, which creates and returns a candidate whose IP address is local to the remote peer. The STUN server then replies to the initiator's request with a candidate whose IP address is unrelated to the remote peer.</dd>
 <dt><code>relay</code></dt>
 <dd>A relay candidate is generated just like a server reflexive candidate (<code>"srflx"</code>), but using {{Glossary("TURN")}} instead of {{Glossary("STUN")}}.</dd>
</dl>

<h3 id="TCP_candidate_types">TCP candidate types</h3>

<p>TCP candidates (that is, candidates whose {{domxref("RTCIceCandidate.protocol", "protocol")}} is <code>tcp</code>) can be of these types:</p>

<dl>
 <dt><code>active</code></dt>
 <dd>The transport will try to open an outbound connection but won't receive incoming connection requests. This is the most common type, and the only one that most user agents will gather.</dd>
 <dt><code>passive</code></dt>
 <dd>The transport will receive incoming connection attempts but won't attempt a connection itself.</dd>
 <dt><code>so</code></dt>
 <dd>The transport will try to simultaneously open a connection with its peer.</dd>
</dl>

<h3 id="Choosing_a_candidate_pair">Choosing a candidate pair</h3>

<p>The ICE layer selects one of the two peers to serve as the <strong>controlling agent</strong>. This is the ICE agent which will make the final decision as to which candidate pair to use for the connection. The other peer is called the <strong>controlled agent</strong>. You can identify which one your end of the connection is by examining the value of {{domxref("RTCIceTransport.role", "RTCIceCandidate.transport.role")}}, although in general it doesn't matter which is which.</p>

<p>The controlling agent not only takes responsibility for making the final decision as to which candidate pair to use, but also for signaling that selection to the controlled agent by using STUN and an updated offer, if necessary. The controlled agent just waits to be told which candidate pair to use.</p>

<p>It's important to keep in mind that a single ICE session may result in the controlling agent choosing more than one candidate pair. Each time it does so and shares that information with the controlled agent, the two peers reconfigure their connection to use the new configuration described by the new candidate pair.</p>

<p>Once the ICE session is complete, the configuration that's currently in effect is the final one, unless an ICE reset occurs.</p>

<p>At the end of each generation of candidates, an end-of-candidates notification is sent in the form of an {{domxref("RTCIceCandidate")}} whose {{domxref("RTCIceCandidate.candidate", "candidate")}} property is an empty string. This candidate should still be added to the connection using {{domxref("RTCPeerConnection.addIceCandidate", "addIceCandidate()")}} method, as usual, in order to deliver that notification to the remote peer.</p>

<p>When there are no more candidates at all to be expected during the current negotiation exchange, an end-of-candidates notification is sent by delivering a {{domxref("RTCIceCandidate")}} whose {{domxref("RTCIceCandidate.candidate", "candidate")}} property is <code>null</code>. This message does <em>not</em> need to be sent to the remote peer. It's a legacy notification of a state which can be detected instead by watching for the {{domxref("RTCPeerConnection.iceGatheringState", "iceGatheringState")}} to change to <code>complete</code>, by watching for the {{domxref("RTCPeerConnection.icegatheringstatechange_event", "icegatheringstatechange")}} event.</p>

<h2 id="When_things_go_wrong">When things go wrong</h2>

<p>During negotiation, there will be times when things just don't work out. For example, when renegotiating a connection—for example, to adapt to changing hardware or network configurations—it's possible that negotiation could reach a dead end, or some form of error might occur that prevents negotiation at all. There may be permissions issues or other problems as well, for that matter.</p>

<h3 id="ICE_rollbacks">ICE rollbacks</h3>

<p>When renegotiating a connection that's already active and a situation arises in which the negotiation fails, you don't really want to kill the already-running call. After all, you were most likely just trying to upgrade or downgrade the connection, or to otherwise make adaptations to an ongoing session. Aborting the call would be an excessive reaction in that situation.</p>

<p>Instead, you can initiate an <strong>ICE rollback</strong>. A rollback restores the SDP offer (and the connection configuration by extension) to the configuration it had the last time the connection's {{domxref("RTCPeerConnection.signalingState", "signalingState")}} was <code>stable</code>.</p>

<p>To programmatically initiate a rollback, send a description whose {{domxref("RTCSessionDescription.type", "type")}} is <code>rollback</code>. Any other properties in the description object are ignored.</p>

<p>In addition, the ICE agent will automatically initiate a rollback when a peer that had previously created an offer receives an offer from the remote peer. In other words, if the local peer is in the state <code>have-local-offer</code>, indicating that the local peer had previously <em>sent</em> an offer, calling <code>setRemoteDescription()</code> with a <em>received</em> offer triggers rollback so that the negotiation switches from the remote peer being the caller to the local peer being the caller.</p>

<h3 id="ICE_restarts">ICE restarts</h3>

<p>For now, see {{SectionOnPage("/en-US/docs/Web/API/WebRTC_API/Session_lifetime", "ICE restart")}}.</p>

<h2 id="The_entire_exchange_in_a_complicated_diagram">The entire exchange in a complicated diagram</h2>

<p><a href="https://hacks.mozilla.org/wp-content/uploads/2013/07/webrtc-complete-diagram.png"><img alt="A complete architectural diagram showing the whole WebRTC process." src="https://mdn.mozillademos.org/files/6119/webrtc-complete-diagram.png" style="display: block; height: 559px; margin: 0px auto; width: 641px;"></a></p>
